/**
 * angular7-adal-css - Fork of angularx-adal from Jonah-Jordan. Azure AD Library - ADAL in Angular 5
 * @version v0.0.5
 * @link https://github.com/pewpewkichu/angular7-adal-css#readme
 * @license MIT
 */
/// <reference types="adal" />
import { Observable } from 'rxjs';
import { OAuthData } from './oauthdata.model';
export declare class AdalService {
    private adalContext;
    private oauthData;
    init(configOptions: adal.Config): void;
    readonly config: adal.Config;
    readonly userInfo: OAuthData;
    login(): void;
    loginInProgress(): boolean;
    logOut(): void;
    handleWindowCallback(): void;
    getCachedToken(resource: string): string;
    acquireToken(resource: string): Observable<any>;
    getUser(): Observable<adal.User>;
    clearCache(): void;
    clearCacheForResource(resource: string): void;
    info(message: string): void;
    verbose(message: string): void;
    GetResourceForEndpoint(url: string): string;
    refreshDataFromCache(): void;
    private updateDataFromCache;
}
